*CMZ :  3.07/01 05/04/2004  20.35.53  by  FRANCHISSEUR Robert
*CMZ :  3.07/00 15/09/98  18.38.58  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 27/07/95  20.20.02  by  Alain LAHELLEC
*CMZ :  3.05/05 03/05/93  13.22.52  by  Jean-Louis DUFRESNE
*CMZ :  3.05/04 18/02/93  15.21.30  by  Jean-Louis DUFRESNE
*CMZ :  3.05/01 11/05/92  20.00.00  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE CCA
c     ==============
C     CCA   CONTROL CARD ANALYZER                        30-JUL-1985
c
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      integer T,IDATQQ,ITIMQQ,UpCase
c
      IF (X(XP).EQ.ET) GO TO 31
      T=UpCase(X(XP))-AMAJ+1
      IF (T.LT.1.OR.26.LT.T) GO TO 11
C
C             A  B  C  D  E  F  G  H  I  J  K  L  M
      GO TO (16,20,23,18,19,11,11,13,22,11,11,14,11,
     *       15,28,11,21,11,26,12,11,11,11,11,11,11),T
C             N  O  P  Q  R  S  T  U  V  W  X  Y  Z
C
   11 CALL ERARE(5,1,2,T+AMAJ-1)
C     ERROR(8) CONTROL CARD ERROR
      RETURN
C
C     B     Space treatment option
   20 if (X(XP+1).EQ.C0) then
        BFLAG=.FALSE.
        XP=XP+1
      else
        BFLAG=.TRUE.
      endif
      return
C
C     T     TRACE
   12 T=X(XP+1)-C0
      if ((T.ge.0).and.(T.le.9)) then
        TFLAG=T
        XP=XP+1
      else
        TFLAG=1
      endif
      if (TFLAG.eq.0) then
        MLINE=53
        LINE=53
      else
        MLINE=10000
      endif
      return
C
C     H     Hollerith
   13 if (X(XP+1).EQ.C0) then
        HFLAG=.FALSE.
        XP=XP+1
      else
        HFLAG=.TRUE.
      endif
      return
C
C     L     LIST
   14 IF (X(XP+1).EQ.C0) then
        LFLAG=.false.
        PFLAG=.true.
        XP=XP+1
      else
        LFLAG=.TRUE.
        PFLAG=.TRUE.
      endif
      RETURN
C
C     N     NO LIST
   15 LFLAG=.FALSE.
      PFLAG=.TRUE.
      RETURN
C
C     A     ANNOTATION FLAG
   16 IF (X(XP+1).EQ.C0) then
        AFLAG=.FALSE.
        XP=XP+1
      else
        AFLAG=.TRUE.
      endif
      RETURN
C
C     D     MACRO DEFINITION TRACE
   18 CALL DTRACE
      RETURN
C
C     E     EJECT
   19 LINE=MLINE
      RETURN
C
C     Q     QUOTE FLAG
   21 IF (X(XP+1).EQ.C0) then
        QFLAG=.FALSE.
        XP=XP+1
      else
        QFLAG=.TRUE.
      endif
      RETURN
C
C     I     INDENTATION
   22 XP=XP+1
      T=X(XP)-C0
      IF (T.LT.0) GO TO 11
      IFLAG=.TRUE.
      IF (T.EQ.0) IFLAG=.FALSE.
      IND=T
      RETURN
C
C     C     Convert in Upper Case
   23 IF (X(XP+1).EQ.C0) then
        UpCaFl=.FALSE.
        XP=XP+1
      else
        UpCaFl=.TRUE.
      endif
      RETURN
C
C
C     S     SUPPRESSES PARENTHESIS CHECKS
   26 IF (X(XP+1).EQ.C0) then
        SFLAG=.FALSE.
        XP=XP+1
      else
        SFLAG=.TRUE.
      endif
      RETURN
C
C     O     MORTRAN MULTI PASSES
C     Output is MORTRAN or FORTRAN
28    XP=XP+1
      if (X(XP).eq.FMAJ) then
        MLTFL = .false.
        return
      else if (X(XP).eq.MMAJ) then
        MLTFL = .true.
        return
      else
        print *,'MTN ERROR : output is nether MORTRAN nor FORTRAN'
        stop 'Error in MTN (CCA) *** ERROR *** ERROR *** ERROR ***'
      endif
C
C     &  FIN DE FICHIER LU ET/OU FIN DU RUN MORTRAN
C     =============================================
C     On depile INUSTP pour lire le numero logique de l'entree suivante
   31 INUSTP=INUSTP-1
C     Si plus de fichier a lire, fin du run MORTRAN
      IF (INUSTP.LE.0) GO TO 32
      close (inu)
      INU=INUNBR(INUSTP)
      RETURN
C     Si plus de fichier a lire, fin du run MORTRAN
   32 CONTINUE
      LINE=LINE+6
      IF (MLINE.LT.LINE) CALL NPAGE
      MP=MPMAX+101
   33 MP=MP-1
      IF (M(MP).EQ.0) GO TO 33
      WRITE(olupr,1001) MP,int( (100*MP)/MDIM)
 1001 FORMAT (/6X,I7,' (',I3,'%) WORDS IN MACRO BUFFER USED')
      XP=XPMAX+101
   34 XP=XP-1
      IF (X(XP).EQ.0) GO TO 34
      WRITE(olupr,1002) XP,int( (100*XP)/XDIM)
 1002 FORMAT (/6X,I7,' (',I3,'%) WORDS IN EXPANSION BUFFER USED')
      PP=PPMAX+101
   35 PP=PP-1
      IF (P(PP).EQ.0) GO TO 35
      WRITE(olupr,1003) PP,int( (100*PP)/PDIM)
 1003 FORMAT (/6X,I7,' (',I3,'%)  WORDS IN PARAMETER BUFFER USED')
      REWIND OUTU
      IF (EFLAG) THEN
         WRITE(olupr,1004)
         WRITE(oluerr,1004)
 1004    FORMAT (/12X,'Warning or error in macro processing')
        ENDFILE OUTU
      ENDIF
C     impression de la version de MORTRAN et de sa date
C     de creation
      ITIMEQQ=1638
      IDATEQQ=20100307
      WRITE(olupr,1005) IDATQQ,ITIMQQ
 1005 FORMAT (/1X,'MORTRAN STOP',5X,
     + 30HMP2A      3.07/01  06/08/2008 
     +,' Installation : ',I8,' at ',I4.4)
      If (EFLAG) then
        stop 'MTN end *** ERROR *** ERROR *** ERROR ***'
      else
        stop 'MTN normal termination'
      endif
      END
C
