*CMZ :          26/11/2008  20.43.51  by  Robert FRANCHISSEUR
*CMZ :  3.07/01 06/08/2008  20.05.07  by  Lahellec Alain
*CMZ :          22/07/2008  20.17.21  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 27/07/95  20.19.07  by  Alain LAHELLEC
*CMZ :  3.05/06 09/02/94  22.32.09  by  Alain LAHELLEC
*CMZ :  3.05/05 03/05/93  15.48.58  by  Jean-Louis DUFRESNE
*CMZ :  3.05/04 24/02/93  18.26.50  by  Jean-Louis DUFRESNE
*CMZ :  3.05/01 11/05/92  20.02.15  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C
C 2008/07/22 on augmente xdim a 200 000 pour eviter le
C MACRO EXPANSION LOOP . OUTPUT OF EXPANSION BUFFER OVERWRITE INPUT
C dans l'exo de Philippe Soler
C
      implicit integer*4 (A-Z)
C
c
C     Parametres modifiable (et le soft se demerde...)
C     ================================================
      integer MDIM,XDIM,PDIM,BDIM,CARDIM,BOUDIM
      parameter (MDIM=800 000,XDIM=200 000,PDIM=4 000,BDIM=4 000)
      parameter (CARDIM=80,BOUDIM=72)
      integer YDIM
      parameter (YDIM=300)
C     xxDIM  : dimension du tableau xx
C     CARDIM : longueur max d'une ligne en entree (et egalement
C              celle de la sortie "lising")
C     BOUDIM : longueur max d'une ligne dans le fichier de sortie
      integer NINUMX,KCHMX
      parameter (NINUMX=15,KCHMX=200)
C     NINUMX : Nombre max d'unite de lecture ouvrable en meme temps
C     KCHMX  : Longeur max de nom de fichiers (attention il reste
C              quelques format A200)
      integer NBDRMX, LBDMX, NDBDMX
      parameter (NBDRMX=30, LBDMX=KCHMX+1,NDBDMX=40)
C     NBDRMX : Nombre max de repertoire de base
C     NDBDMX : Nombre max de repertoire possible par repertoire de base
C     LBDMX  : Longeur max de nom de repertoire de base
      integer NERRMX,NWARMX
      parameter (NERRMX=10,NWARMX=20)
C     NERRMX : nombre max d'erreur MORTRAN avant arret
C     NWARMX : idem avec warning
C
C     Parametres des caracteres de MORTRAN
C     ===================================
C     Declaration des parametres lies aux caracteres
      integer S0,S1,S2,S3,S4,S5,S6,S7,S8,S9,S10,S11,S12,S13,S14,S15
     +  ,S16,S17,S18,S19,S20,S21,S22,S23,S24,S25,S26,S27
     +  ,S28,S29,S30,S31,S32,S33
      integer NUL,BLANC,PTVIRG,DBLCOT,COTE,DIEZE,ET,DBLPT,AT,DOLLAR
     +  ,EGALE,INF,SUP,PAROUV,PARFER,PLUS,MOIN,ETOILE,SLASH,CROOUV
     +  ,CROFER,VIRGUL,POINT,PTINTE,BARVRT,ANTSLA,SOULIG
     +  ,PRCT,ANTCOT,PTEXCL,ACOOUV,ACOFER,TILDA,CHAPO
      integer AMAJ,BMAJ,CMAJ,DMAJ,EMAJ,FMAJ,GMAJ,HMAJ,IMAJ,JMAJ
     +  ,KMAJ,LMAJ,MMAJ,NMAJ,OMAJ,PMAJ,QMAJ,RMAJ,SMAJ,TMAJ,UMAJ,VMAJ
     +  ,WMAJ,XMAJ,YMAJ,ZMAJ
      integer C0,C1,C2,C3,C4,C5,C6,C7,C8,C9
      integer amin,bmin,cmin,dmin,emin,fmin,gmin,hmin,imin,jmin
     +  ,kmin,lmin,mmin,nmin,omin,pmin,qmin,rmin,smin,tmin,umin,vmin
     +  ,wmin,xmin,ymin,zmin
C
C     definition brut du block de caractere speciaux
C     ===> ne plus utiliser
      parameter (S0=0)
      parameter (S1=S0+1,S2=S0+2,S3=S0+3,S4=S0+4,S5=S0+5,S6=S0+6
     +  ,S7=S0+7,S8=S0+8,S9=S0+9,S10=S0+10,S11=S0+11,S12=S0+12
     +  ,S13=S0+13,S14=S0+14,S15=S0+15,S16=S0+16,S17=S0+17,S18=S0+18
     +  ,S19=S0+19,S20=S0+20,S21=S0+21,S22=S0+22,S23=S0+23,S24=S0+24
     +  ,S25=S0+25,S26=S0+26,S27=S0+27,S28=S0+28,S29=S0+29,S30=S0+30
     +  ,S31=S0+31,S32=S0+32,S33=S0+33)
C     definition "evoluee" du block de caractere speciaux
      parameter (NUL=S0,BLANC=S1,PTVIRG=S2,DBLCOT=S3,COTE=S4,DIEZE=S5
     +,ET=S6,DBLPT=S7,AT=S8,DOLLAR=S9,EGALE=S10,INF=S11,SUP=S12
     +,PAROUV=S13,PARFER=S14,PLUS=S15,MOIN=S16,ETOILE=S17,SLASH=S18
     +,CROOUV=S19,CROFER=S20,VIRGUL=S21,POINT=S22,PTINTE=S23,BARVRT=S24
     +,ANTSLA=S25,SOULIG=S26,PRCT=S27,ANTCOT=S28,PTEXCL=S29
     +,ACOOUV=S30,ACOFER=S31,TILDA=S32,CHAPO=S33)
C     definition du block de caracteres alphabetiques en majuscule
      parameter (AMAJ=S33+1)
      parameter (BMAJ=AMAJ+1,CMAJ=AMAJ+2,DMAJ=AMAJ+3,EMAJ=AMAJ+4
     +  ,FMAJ=AMAJ+5,GMAJ=AMAJ+6,HMAJ=AMAJ+7,IMAJ=AMAJ+8,JMAJ=AMAJ+9
     +  ,KMAJ=AMAJ+10,LMAJ=AMAJ+11,MMAJ=AMAJ+12,NMAJ=AMAJ+13
     +  ,OMAJ=AMAJ+14,PMAJ=AMAJ+15,QMAJ=AMAJ+16,RMAJ=AMAJ+17
     +  ,SMAJ=AMAJ+18,TMAJ=AMAJ+19,UMAJ=AMAJ+20,VMAJ=AMAJ+21
     +  ,WMAJ=AMAJ+22,XMAJ=AMAJ+23,YMAJ=AMAJ+24,ZMAJ=AMAJ+25)
C     definition du block de caracteres numeriques
      parameter (C0=ZMAJ+1)
      parameter (C1=C0+1,C2=C0+2,C3=C0+3,C4=C0+4,C5=C0+5,C6=C0+6
     +  ,C7=C0+7,C8=C0+8,C9=C0+9)
C     definition du block de caracteres alphabetiques en minuscule
      parameter (amin=C9+1)
      parameter (bmin=amin+1,cmin=amin+2,dmin=amin+3,emin=amin+4
     +  ,fmin=amin+5,gmin=amin+6,hmin=amin+7,imin=amin+8,jmin=amin+9
     +  ,kmin=amin+10,lmin=amin+11,mmin=amin+12,nmin=amin+13
     +  ,omin=amin+14,pmin=amin+15,qmin=amin+16,rmin=amin+17
     +  ,smin=amin+18,tmin=amin+19,umin=amin+20,vmin=amin+21
     +  ,wmin=amin+22,xmin=amin+23,ymin=amin+24,zmin=amin+25)
C
C  stb_nul permet de mettre un 'zero' dans la stack
C  caractere 'Record separator' 0x1E rentre avec <Ctrl>^
C  vu comme ^^ (ou  sous ceterm)
C  Aout 08 : utilise encore pour #N, operation no-rescan escape, cf mp2
      parameter (stb_nul=zmin+1)
C  destine a remplacer "**", =elevation a la puissance de Fortran
      parameter (starstar=stb_nul+1)
C
C     Parametres des tableaux de MORTRAN
C     ==================================
C
      integer NPMAX,NSTPMX
      parameter (NPMAX=9,NSTPMX=9)
      integer MIDIM,BINDIM,LLCTMX
      parameter (MIDIM=97)
      parameter (BINDIM=CARDIM+2,LLCTMX=CARDIM+15)
C     valeur pour initilialiser ces tableaux et pour controler
C     le depassement de ces tableaux
      integer XPBREF
      integer MPMAX,XPMAX,PPMAX,SPMAX
* expansion buffer a 10000
      parameter (XPBREF=XDIM-10000)
* expansion buffer a 1000
      parameter (MPMAX=MDIM-100, XPMAX=XDIM-1000, PPMAX=PDIM-500)
      parameter (SPMAX=50)
