*CMZ :          07/03/2010  16.02.58  by  Patrice Dumas
*CMZ :  3.07/00 08/12/98  16.20.07  by  Robert FRANCHISSEUR
*CMZ :  3.06/04 10/06/98  05.25.56  by  Robert FRANCHISSEUR
*CMZ :  3.06/01 05/06/96  18.01.34  by  Robert FRANCHISSEUR
*CMZ :  3.05/09 29/02/96  16.30.08  by  Robert FRANCHISSEUR
*CMZ :  3.05/08 01/11/95  22.15.03  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 14/09/94  23.50.33  by  Robert FRANCHISSEUR
*CMZ :  3.05/05 02/05/93  16.52.14  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.49  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE FILMAN(STR)
C     =====================
C
C     FILE MANAGER
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      character*(*) STR
      character*1 C
      character*(KCHMX) FILNAM
      logical UFL,VFL,RFL,BFL,NAME
      integer NOSTAT,T,TT
      character*(KCHMX) DIRNAM
      character*(KCHMX + LBDMX) BDFIL
      character*(LBDMX) BDNAM
      character*(LBDMX) DBDIRS(NDBDMX - 1)
      character*(LBDMX) BDDIR
      integer DBIDX,BDEND,i,j,DBNR,EQIDX,STAT
      integer LENOCC
      logical ALFANU
      integer LENSTR

C
C     ===== on regarde si c'est une operation sur un fichier  ======
C           sinon on retourne
      UFL=.false.
      VFL=.false.
      RFL=.false.
      BFL=.false.
C
      C=STR(2:2)
      if (C.eq.'U'.or.C.eq.'u') then
        UFL=.true.
      elseif (C.eq.'V'.or.C.eq.'v') then
        VFL=.true.
      elseif (C.eq.'R'.or.C.eq.'r') then
        RFL=.true.
      elseif (C.eq.'B'.or.C.eq.'b') then
        BFL=.true.
      else
        return
      endif
C
C     ===== intructions commune aux operations sur un fichier  ======
C
      if (LFLAG) call AFFICH(STR)
C
C     Recherche du nom de fichier ou du numero d'unite logique
C
C     On extrait les carcters suivant &x
      if (LENOCC(STR).gt.KCHMX+2) call ERARE(4,1,3,LENOCC(STR))
      FILNAM=STR(3:LENOCC(STR))
      if (LENOCC(FILNAM).eq.0) call ERARE(4,1,3,0)

C     On met STR a blanc pour le test au retour , dans READ
      STR=' '

      if (BFL) then
        goto 400
      endif

C     On regarde si c'est un numero d'unite logique (entier < 99)
      NAME=.true.
      if (LENOCC(FILNAM).le.2) then
        C=FILNAM(1:1)
        if (C.ge.'0'.and.C.le.'9') then
          T=ICHAR(C)-ICHAR('0')
          C=FILNAM(2:2)
          if (C.ge.'0'.and.C.le.'9') then
            T=T*10+ICHAR(C)-ICHAR('0')
            NAME=.false.
          elseif (C.eq.' ') then
            NAME=.false.
          endif
        endif
      endif
C
C     Quelques GOTO pour le principe
      if (UFL) then
        goto 100
      else if (RFL) then
        go to 200
      else if (VFL) then
        go to 300
      endif

C
C     ===========  U     INPUT FILE   ============
C
 135    format(1x,' INU',I4,' FILE NAME :  ',A200)

100   if (NAME) then
        INUOPN=INUOPN+1
        INU=INUOPN
        DBNR = 0
        if (FILNAM(1:1) .eq. '#') then
C first we find the base name
          do 118 BDEND=2,min(KCHMX,len(FILNAM)-1)
            if (ALFANU(ITAB(IACHAR(FILNAM(BDEND:BDEND))))) then
               BDNAM(BDEND-1:BDEND-1) = FILNAM(BDEND:BDEND)
            else
               goto 119
            end if
118       continue
119       continue
          BDNAM(BDEND-1:BDEND-1) = achar(0);
C          print *,'search basedir(',LENSTR(BDNAM),BDEND,'):', BDNAM
          if (LENSTR(BDNAM) .gt. 0) then
C            call FINDBD(BDNAM,BDIRS,DBDIRS,DBNR)
            call FINDBD(BDNAM,DBDIRS,DBNR)
C            print *, 'base dir number of entries found:', DBNR
          end if
        end if
        if (DBNR .gt. 0) then
          do 125 DBIDX=1, DBNR
C            print *, DBIDX, ' ', DBDIRS(DBIDX)
            BDDIR = DBDIRS(DBIDX)
            BDFIL =
     +        BDDIR(1:LENSTR(BDDIR))//FILNAM(BDEND:len(FILNAM))
            OPEN(INU,FILE=BDFIL,STATUS='OLD',IOSTAT=NOSTAT
     +        ,RECL=LLCTMX,FORM='FORMATTED')
            if (NOSTAT.eq.0) then
              print 135,INU,BDFIL
              goto 150
            end if
125       continue
        end if
        print 135,INU,FILNAM
        OPEN(INU,FILE=FILNAM,STATUS='OLD',IOSTAT=NOSTAT
*+SELF,IF=SUN,CRAY,IBMRT,ALPHA,LNX,HPUX,PGF.
*     +       ,FORM='FORMATTED')
*+SELF,IF=-SUN,IF=-CRAY,IF=-IBMRT,IF=-ALPHA,IF=-LNX,IF=-HPUX,IF=-PGF.
     +       ,RECL=LLCTMX,FORM='FORMATTED')
*+SELF.
        if (NOSTAT.ne.0) call ERARE(4,2,3,NOSTAT)
150     continue
      else
        INU=T
        FILNAM=' '
      endif
C     On incremente le pointeur de pile
      INUSTP=INUSTP+1
      if (INUSTP.gt.NINUMX) call ERARE(4,3,3,INUSTP)
C     on conserve dans des piles le numero et le nom de fichier
      INUNBR(INUSTP)=INU
      INUNAM(INUSTP)=FILNAM
C
      return
C
C     ===========  R     REWIND  FILE  ============
C
  200 XP=XP+1
      T=X(XP)-C0
c      IF ((T.LT.1).OR.(T.GT.9)) GO TO 11
C     READ THE SECOND DIGIT, IF EXIST
      TT=X(XP+1)-C0
      IF ((TT.GE.0).AND.(TT.LE.9)) THEN
        T=10*T+TT
C       INCREMENT XP POINTER
        XP=XP+1
      ENDIF
      REWIND T
      RETURN
C
C     ===========  V     NEW OUTPUT FILE   ============
C
  300 CONTINUE
C     On ferme le fichier de sortie precedent
      CLOSE (OUTU)
C
      print 310,OUTU,FILNAM
 310  format(1x,'OUTU',I4,' FILE NAME :  ',A200)
      OPEN(OUTU,FILE=FILNAM,STATUS='UNKNOWN',IOSTAT=NOSTAT
*+SELF,IF=SUN,CRAY,IBMRT,ALPHA,LNX,HPUX,PGF.
*     +       ,FORM='FORMATTED')
*+SELF,IF=-SUN,IF=-CRAY,IF=-IBMRT,IF=-ALPHA,IF=-LNX,IF=-HPUX,IF=-PGF.
     +       ,RECL=LLCTMX,FORM='FORMATTED')
*     +       ,RECL=BOUDIM,FORM='FORMATTED')
*+SELF.
      if (NOSTAT.ne.0) then
        print *,'File ',FILNAM,' can''t be open'
        stop 'Error in MTN (FILMAN) *** ERROR *** ERROR *** ERROR ***'
      endif
      RETURN
C
C
C     ===========  V     BASE DIR ASSOCIATION   ============
C
  400 CONTINUE
      EQIDX = index(FILNAM,'=')
      if (EQIDX .eq. 0) then
        print *, 'Error no =:', FILNAM
      else if (EQIDX .eq. 1) then
        print *, 'Error nothing before =:', FILNAM
      else if (EQIDX+1 .gt. LBDMX) then
        print *, 'base name too long:', FILNAM
      else if ((lenocc(FILNAM) + 1 - EQIDX) .gt. KCHMX) then
        print *, 'directory too long:', FILNAM
      else if (lenocc(FILNAM) .eq. EQIDX) then
        print *,'Need a directory to be associated with a base',FILNAM
      else
        do 1018 BDEND=1,EQIDX-1
          if (ALFANU(ITAB(IACHAR(FILNAM(BDEND:BDEND))))) then
             BDNAM(BDEND:BDEND) = FILNAM(BDEND:BDEND)
            else
               print *, 'non alnum char in name', FILNAM
               return
            end if
1018    continue
        BDNAM(BDEND:BDEND) = achar(0)
C          print *, 'BDNAM:',BDNAM, ',BDEND:',BDEND
        DIRNAM = FILNAM(EQIDX+1:LENOCC(FILNAM))
C          print *, '!!', FILNAM(EQIDX+1:LENOCC(FILNAM)),
C     +'!',LENOCC(FILNAM)-EQIDX
        DIRNAM(LENOCC(FILNAM)-EQIDX+1:LENOCC(FILNAM)-EQIDX+1)
     +         = achar(0)
C        call ADDBD(BDNAM,BDIRS,DIRNAM,STAT)
        call ADDBD(BDNAM,DIRNAM,STAT)
        if (STAT .lt. 0) print *, 'No place left for basedir',FILNAM
      end if

      RETURN
      END
