*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C
      subroutine FINMAC(MPBEG,XTMP,NCAR,MPPREV,MPCUR,MPNEXT,MPREPL)
C     ==============================================================
C
C     Recherche d'une macro correspondant au contenu de XTMP, a partir de
C     XTMP(1), sur au maximum NCAR caractere et jusqu'a trouver une valeur
C      nulle (fin de macro)
C     Entree :
C     - MPBEG : adresse de la macro a partir de laquelle on effectue la recherch
C     (On commence a chercher les macro a partie de M(MPBEG) )
C     - XTMP  : Tableau contenant le texte de reference
C     - NCAR  : Nombre max de caracteres sur lequel portera la comparaison des m
C     Si NCAR = 0, ce nombre est illimite.
C     Sortie :
C     - MPCUR  : adresse de la macro recherche ( =0 si pas trouve)
C     - MPPREV : adresse de la macro precedente
C     - MPNEXT : adresse de la macro suivante
C     - MPREPL : adresse de la partie REPALCEMENT de la macro trouvee
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      integer MPBEG,XTMP,NCAR,MPPREV,MPCUR,MPNEXT,MPREPL,MP1,MP2
     *        ,N,N2CAR
      dimension XTMP(1000)
C
C     Initialisation des variables
      N2CAR = NCAR
      if (N2CAR.eq.0) N2CAR = 1000
      MPPREV = MPBEG
C
C     Boucle sur les macro
100   continue
        MPCUR = M(MPPREV)
C       Si MPCUR = 0, macro not found
        if (MPCUR.eq.0) then
          MPNEXT = 0
          return
        endif
        MPNEXT = M(MPCUR)
        MP2 = MPCUR
        MP1 = 0
        N = 0
C       Boucle sur les caracteres des macro
200     continue
          MP2 = MP2+1
          MP1 = MP1+1
          N = N+1
C
C         Si la comparaison a ete faite jusqu'a la fin des macro
          if (M(MP2).eq.0.and.XTMP(MP1).eq.0) then
C           adresse de la partie remplacement
            MPREPL = MP2+1
            return
          endif
C
C         Si le nombre de caractere sur lequel porte la comparaison est atteind
          if (N .gt. N2CAR) then
C           on va checher l'adresse de la partie remplacement
210         continue
              if (M(MP2).eq.0) then
C               adresse de la partie remplacement
                MPREPL = MP2+1
                return
              endif
              MP2 = MP2+1
            go to 210
          endif
C
        if (M(MP2).eq.XTMP(MP1))goto 200
C       Si il n'y a pas correspondance, on va chercher la macro suivante
        MPPREV = MPCUR
      go to 100
      END
