*CMZ :  3.07/01 06/08/2008  21.54.31  by  Lahellec Alain
*CMZ :  3.07/00 15/09/98  19.43.36  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 15/09/94  01.16.37  by  Robert FRANCHISSEUR
*CMZ :  3.05/05 02/05/93  16.55.08  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.48  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE OUT
C     ==============
C
C    15/2/90 JLD; Aout 2008, Al1: starstar internal char -> "**" FTN
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
      LOGICAL STNST
      LOGICAL STRFL,WFLAG,FBEG
      LOGICAL NUMERI
C     WFLAG : vrai si on enregistre des commentaire (instruction #*....)
C     STRFL : vrai si on est a l'interieur d'une chaine de caracteres
C             (entre cote)
      integer OPBEG,LPOUT,COMBEG,I,L,T,L1,L2,CONT
      DIMENSION COMBEG(50)
C     Variables locales ne devant pas etre volatiles
      common /OUTCDE/ CONT(8),LPOUT,STNST
      DATA LPOUT/0/STNST/.false./
C     on definit la chaine de caratere CONTINUE
      DATA CONT/CMAJ,OMAJ,NMAJ,TMAJ,IMAJ,NMAJ,UMAJ,EMAJ/
C
C     on met a zero le pointeur de X
      OP=0
C-
C--  traitement d'une instruction MORTRAN (jusqu'au premier ;)
C-------------------------------------------------------------
      if (.not.MLTFL) go to 10
C
C     ==== SI LA SORTIE EST EN MORTRAN ====
C
c
      STRFL=.false.
C     ==> LOOP lct_instruction_mtn
100   continue
C       on initialise le pointeur du buffer de sortie
        POUT = 0
110     OP = OP+1
        T=X(OP)
C       on supprime les blancs et les ; qui sont au debut de la ligne
        IF (T.EQ.BLANC.OR.T.EQ.PTVIRG) GOTO 110
        IF (T.EQ.DIEZE.AND.X(OP+1).EQ.ETOILE) THEN
          WFLAG=.TRUE.
          BOUT(1)=PTEXCL
          POUT=1
          OP=OP+1
          GOTO 140
        ENDIF
        WFLAG=.FALSE.
C       ==> EXIT LOOP lct_instruction_mtn
        if (T.eq.NUL) GO TO 150
        OP = OP-1
C       ===>> LOOP lct_car
140     OP=OP+1
C         lecture du caractere suivant
          T=X(OP)
          if (T.eq.NUL) then
            print *,'MTN ERROR IN ROUTINE OUT: LINE FINISH WITHOUT (;)'
            call MWRITE
        stop 'Error in MTN (OUT) *** ERROR *** ERROR *** ERROR ***'
          endif
C         On met le caractere lu dans le buffer de sortie
          POUT = POUT+1
          BOUT(POUT)=T
          IF (BOUDIM.LE.POUT)  GOTO 131
C         gestion de STRFL en balance
          if (T.eq.COTE) STRFL = .not.STRFL
C         Tant que l'on est a l'interieur d'une chaine de
C         caracteres ou qu'il n'y a pas de ; on boucle
C       ===>> END LOOP lct_car
        if ((STRFL) .or. (T.ne.PTVIRG)) go to 140
C
C       si c'est un ; on enregistre la ligne (buffer BOUT)
        call MWRITE
C     ==> END LOOP lct_instruction_mtn
      GO TO 100
  131 continue
      IF (WFLAG)  THEN
C--      Analysis of beginnig of line to be duplicated in C- cont line
        FBEG=.TRUE.
        DO 311 I=1,50
        IF (FBEG.AND.BOUT(I).NE.BLANC)  GOTO 311
        FBEG=.FALSE.
        IF (BOUT(I).NE.BLANC)  GOTO 312
  311   CONTINUE
  312   OPBEG=I-1
        DO 313 I=1,OPBEG
  313   COMBEG(I)=BOUT(I)
        CALL MWRITE
        DO 314 I=1,OPBEG
  314   BOUT(I)=COMBEG(I)
        POUT=OPBEG
C
                  ELSE
        FBEG=.FALSE.
        IF (BOUT(POUT).EQ.BLANC)  FBEG=.TRUE.
        CALL MWRITE
        IF (FBEG)  THEN
          BOUT(1)=BLANC
          POUT=1
                   ELSE
          POUT=0
        ENDIF
C
      ENDIF
      GOTO 140
C
C     Fin d'ecriture d'instructions MORTRAN. Quelques tests.
150   continue
      if (STRFL) then
        print *,'MTN ERROR IN ROUTINE OUT'
        print *,'UNCLOSED QUOTED STRING'
        call MWRITE
        stop 'Error in MTN (OUT) *** ERROR *** ERROR *** ERROR ***'
      endif
C
      return
C
C     ==== SI LA SORTIE EST EN FORTAN ====
C
   10 OP=OP+1
      T=X(OP)
C     return quand le caractere nul est rencontre
      IF (T.EQ.NUL) RETURN
C     on supprime les blancs et les ; qui sont au debut
      IF (T.EQ.BLANC.OR.T.EQ.PTVIRG) GOTO 10
      IF (T.EQ.DIEZE.AND.X(OP+1).EQ.ETOILE) GOTO 50
      WFLAG=.FALSE.
C     si premier passage, on remplit la table MI pour sauvegarder
C     les macro existantes
      if (FFLAG) then
        call SAVEMI
        FFLAG = .false.
      endif
C     si le premier caractere n'est pas un chiffre, ce n'est pas un label
   11 IF (.not.NUMERI(T)) GO TO 15
C-
C--   traitement des etiquettes de lignes
C----------------------------------------
C
C     STATEMENT NUMBER
      LPOUT=0
C     si l'on ne viend pas de transferer une etiquette
      IF (.NOT.STNST) GO TO 13
C     si l'on viend de traiter une etiquette, on genere un instruction CONTINUE
      POUT=6
      DO 12 I=1,8
      POUT=POUT+1
   12 BOUT(POUT)=CONT(I)
      CALL MWRITE
C     on positione le flag disant que l'on viend de traiter une etiquette
   13 STNST=.TRUE.
C     reset du pointeur de BOUT
      POUT=0
C     on met les chiffres de l'etiquette dans BOUT, jusqu'au premier ;
   14 IF (X(OP).EQ.PTVIRG) GO TO 10
      POUT=POUT+1
C     si etiquette a plus de 6 chiffres, erreur
      IF (6.LE.POUT) GO TO 41
      BOUT(POUT)=X(OP)
      OP=OP+1
      GO TO 14
C-
C--   Comments Card to be Generated
C----------------------------------
C
   50 IF (.NOT.STNST) GO TO 53
c      After a LABEL, a CONTINUE must be generated
      POUT=6
      DO 52 I=1,8
      POUT=POUT+1
   52 BOUT(POUT)=CONT(I)
      CALL MWRITE
c-    now treats the #* mark sign for C- Fortran card.
   53 STNST=.FALSE.
      BOUT(1)=CMAJ
      POUT=1
      OP=OP+1
      WFLAG=.TRUE.
      GOTO 16
C-
C--   traitement des instructions FORTRAN
C----------------------------------------
C
C     STATEMENT BODY
   15 STNST=.FALSE.
C     on saute les 6 premieres colonnes
      POUT=6
C     si LPOUT<>0, on concatenne 2 instructions MORTRAN. LPOUT pointe
C     sur la case de BOUT ou il faut ecrire. T contiend le 1er
C     caractere de la nouvelle instruction MORTRAN (on a ete en 10)
      IF (LPOUT.NE.0) POUT=LPOUT
      GO TO 17
C     lecture du caractere suivant
   16 OP=OP+1
      T=X(OP)
C     si ('), alors chaine de caractere. On convertit en hollerith. Retour en 18
   17 IF (T.EQ.COTE) GO TO 21
C     si ; ,alors fin d'instruction MORTRAN. On appelle MWRITE (sauf en cas de
C     concatenation. On revient en 10. ==SORTIE DE BOUCLE==
      IF (T.EQ.PTVIRG) GO TO 34
C     si _ ,on supprime ce caractere.
C      IF (T.EQ.SOULIG) GO TO 16  --a bien faire flag...
C     si plus de BOUDIM caracteres, on ecrit la ligne actuelle. On genere une
C     nouvelle ligne avec un caractere suite, on reviend en 18
      IF (BOUDIM.LE.POUT) GO TO 31
C     On transmet le caractere a BOUT
   18 POUT=POUT+1
C detection de mp2 StarStar to be output as "**" power-to ftn convention
      IF (T.eq.StarStar) then
       T=Etoile
       Bout(Pout)=T
       GoTo 17
      endif
      BOUT(POUT)=T
      GO TO 16
C-
C--   traitement des chaines de caracteres (conversion en hollerith)
C-------------------------------------------------------------------
C
C     STRING
   21 if (HFLAG) then
      L = OP
   22 L=L+1
C     On va chercher le prochain '
      IF (X(L).NE.COTE) GO TO 22
C     longueur de la chaine
      L=L-OP-1
      IF (L.EQ.0) GO TO 26
      L1=L/10
      L2=L-10*L1
C     gestion de la carte suite.
      IF ((BOUDIM-2).LE.POUT) THEN
        CALL MWRITE
        BOUT(6)=ETOILE
        POUT=6
      ENDIF
   23 BOUT(POUT+1)=L1+C0
      BOUT(POUT+2)=L2+C0
      BOUT(POUT+3)=HMAJ
      POUT=POUT+3
   24 OP=OP+1
      IF (X(OP).EQ.COTE) GO TO 16
C     gestion de la carte suite.
      IF (BOUDIM.LE.POUT) THEN
        CALL MWRITE
        BOUT(6)=ETOILE
        POUT=6
      ENDIF
   25 POUT=POUT+1
      BOUT(POUT)=X(OP)
      GO TO 24
   26 OP=OP+1
      GO TO 18
C
C     Si pas de conversion en Hollerith   (else de HFLAG)
      else
28      continue
          call OUTCHA
          OP = OP+1
        if (X(OP).ne.cote) go to 28
        call OUTCHA
        GO TO 16
      endif
C-
C--   traitement des lignes suites
C---------------------------------
C     On ecrit la ligne existante, on genere un caractere suite (*) pour la
C     nouvelle ligne. Le GOTO finale correspond a un RETURN
C
   31 IF (WFLAG)  THEN
C--      Analysis of beginnig of line to be duplicated in C- cont line
        FBEG=.TRUE.
        DO 301 I=1,50
        IF (FBEG.AND.BOUT(I).NE.BLANC)  GOTO 301
        FBEG=.FALSE.
        IF (BOUT(I).NE.BLANC)  GOTO 302
  301   CONTINUE
  302   OPBEG=I-1
        DO 303 I=1,OPBEG
  303   COMBEG(I)=BOUT(I)
        CALL MWRITE
        DO 304 I=1,OPBEG
  304   BOUT(I)=COMBEG(I)
        POUT=OPBEG
                   ELSE
        CALL MWRITE
        BOUT(6)=ETOILE
        POUT=6
      ENDIF
      GO TO 18
C-
C--  On ecrit l'instruction MORTRAN lu dans X, sauf en cas de concatenation
C--------------------------------------------------------------------------
C
C     si le caractere precedent le ; est un $, il y a concatenation
   34 IF (X(OP-1).EQ.DOLLAR) GO TO 35
      CALL MWRITE
      LPOUT=0
C     lecture de la prochaine instruction MORTRAN
      GO TO 10
C     On garde en memoire le pointeur d'ecriture dans BOUT
   35 LPOUT=POUT-1
      STNST=.TRUE.
      GO TO 10
C-
C--  ERREUR
C-----------
C
   41 T=X(OP)
      CALL ERARE(3,5,2,T)
C     ERROR(16) ERROR IN STATEMENT LABEL
      GO TO 15
C-
      END
C
