#! /bin/sh
###############################################################
#
#set -x
MTNDEPEND=../scripts/mtndepend
export MTNDEPEND
MTN=../src/mtn
export MTN
if [ "z$srcdir" = "z" ]; then
	srcdir=.
fi
# if the srcdir is not the curent dir the test dependency paths change
if [ $srcdir != . ]; then
	exit 77
fi
rm -f test_depend_nested.d test_depend_nested.f
../scripts/mortran -MMD -MP -isystem$srcdir/../mac -I$srcdir $srcdir/test_depend_nested.mtn > test_depend_nested.f
exit_error=$?
if [ $exit_error != 0 ]; then
	exit $exit_error
fi

# diff -u is more readable but not available on all platforms.
diff $srcdir/test_depend_nested.d.ok test_depend_nested.d
exit_error=$?
if [ $exit_error != 0 ]; then
	exit $exit_error
fi

diff $srcdir/test_depend_nested.f.ok test_depend_nested.f
exit $?
