#! /bin/sh
###############################################################
#
if [ "z$srcdir" = "z" ]; then
	srcdir=.
fi

rm -f test_includes.lis test_includes.output

../src/mtn >> test_includes.lis <<EOI
&vtest_includes.output
&u$srcdir/../mac/mtn.mac
&bbase=$srcdir
&bbase=$srcdir/includes
&u#base/include_n.mti
&bbase2=$srcdir/../test/includes/.././includes/.//
&u#base2/include_n.mti
EOI
exit_error=$?
if [ $exit_error != 0 ]; then
	exit $exit_error
fi

# diff -u is more readable but not available on all platforms.
diff $srcdir/test_includes.output.ok test_includes.output
exit $?
