*CMZ :  3.07/01 28/05/2008  16.20.10  by  Robert FRANCHISSEUR
*CMZ :  3.07/00 15/09/98  18.37.01  by  Robert FRANCHISSEUR
*CMZ :  3.05/07 13/09/94  12.55.22  by  Robert FRANCHISSEUR
*CMZ :  3.05/05 03/05/93  18.22.30  by  Jean-Louis DUFRESNE
*CMZ :  3.05/04 09/02/93  09.33.01  by  Jean-Louis DUFRESNE
*CMZ :  3.05/00 11/05/92  19.48.49  by  Jean-Louis DUFRESNE
*-- Author :
C     ===============================================================
      SUBROUTINE ERARE(JCODE,SUBCOD,LEVEL,T)
c     ======================================
c
C     JCODE  : CODE ERROR
C     SUBCOD : SUB-CODE ERROR
C     LEVEL  : SEVERITY  LEVEL : 1:warning; 2:error; 3:fatal error
C     T      : Parameter (en generale un caracter en codage interne)
C
*KEEP,defpar.
#include "defpar.inc"
*KEND.
*KEEP,mp2cde.
#include "mp2cde.inc"
*KEND.
*KEEP,xincde.
#include "xincde.inc"
*KEND.
      integer JCODE,SUBCOD,LEVEL,T
      integer XPLOC,IDATQQ,ITIMQQ
      integer MpLoc, BP ,I
c
      if (jcode.lt.9) then
        if (LEVEL.eq.0) then
          print *
        elseif (LEVEL.eq.1) then
          write (olupr,100)
100       format(1x,'*** MTN WARNING ***',8x,$)
        elseif (LEVEL.eq.2) then
          write (olupr,101)
101       format(1x,'***  MTN ERROR  ***',8x,$)
        elseif (LEVEL.eq.3) then
          write (olupr,102)
102       format(1x,'***  MTN FATAL  ***',8x,$)
        endif
C
C     if Use Define Messages
      else
        if (LEVEL.eq.0) then
          print *
        elseif (LEVEL.eq.1) then
          write (olupr,200)
200       format(1x,'*** WARNING ***')
        elseif (LEVEL.eq.2) then
          write (olupr,201)
201       format(1x,'***  ERROR  ***')
        elseif (LEVEL.eq.3) then
          write (olupr,202)
202       format(1x,'***  FATAL ERROR  ***')
        endif
      endif
c
      if (LEVEL.eq.0) then
        NMESS=NMESS+1
      elseif (LEVEL.eq.1) then
        NWARN=NWARN+1
        NTWARN=NTWARN+1
      elseif (LEVEL.eq.2) then
        NERR=NERR+1
        NTERR=NTERR+1
        EFLAG=.true.
      elseif (LEVEL.eq.3) then
        NERR=NERR+1
        NTERR=NTERR+1
        EFLAG=.true.
      else
        write (olupr,*) ' ***  MTN BUG IN ERARE  ***'
        WRITE(olupr,105)
        STOP 'Error in MTN (ERARE) *** ERROR *** ERROR *** ERROR ***'
      endif
C
      GO TO (1000,2000,3000,4000,5000,6000,7000,8000,9000),JCODE
        write (olupr,*) ' ***  MTN BUG IN ERARE  ***'
        WRITE(olupr,105)
        STOP 'Error in MTN (ERARE) *** ERROR *** ERROR *** ERROR ***'
C
C     ========= JCODE = 1 : MACRO DEFINITION ERRORS ==========
C
1000  continue
      write (olupr,1900)
1900  format (' ERROR IN MACRO DEFINITION')
C
      GO TO (1010,1020,1030,1040,1050,1060,1070,1080,1090),SUBCOD
C
1010  print 1011,T
1011  format (' TOO MANY PARAMETERS ; NP =',I2)
      GO TO 1999
C
1020  print 1021,T
1021  format(' PARAMETER NUMBER ',I2,' NOT IN PATTERN')
      GO TO 1999
C
1030  print 1031,OTAB(T)
1031  format(' ILLEGAL OPERATION ; BAD CHARACTER IS :',A1)
      GO TO 1999
C
1040  print 1041
1041  format(' ILLEGAL OPERATION PARAMETER')
      print 1042,OTAB(MP),OTAB(T)
1042  format(' OPERATION IS :#',A1,'   BAD PARAMETER IS :',A1)
      GO TO 1999
C
1050  print 1051,OTAB(X(XP))
1051  format(' Character found:',A1)
      print 1052,OTAB(T)
1052  format(' Character expected:',A1)
      print *,'Begining of the macro is:'
      write(olupr,CARFMT) BLANC,(OTAB(X(XPLOC)),XPLOC=XPB,XP)
      GO TO 1999
C
1060  print 1061,T
1061  format(' STACK UNDERFLOW WITH STACK NUMBER ',I2)
      GO TO 1999
1070  print 1071
1071  format('Do not begin a macro with ;# and do not finish',
     *' a macro with #')
      GO TO 1999
1080  print 1081
1081  format(' ')
      GO TO 1999
1090  print 1091
1091  format(' ')
      GO TO 1999
C
C     impression systematique
1999  continue
C     si SUBCOD=5, la macro n'est pas encore rangee dans M
      if (SUBCOD.ne.5) then
C       Matched text
        call TRACE(3,XPB,XP+1)
C       Pattern part of the macro
        call TRACE(1,XPB,MPB)
C       Parameters
        call TRACE(2,1,NP)
C       Replacement part of the macro
        call TRACE(5,XPB,MPB)
      endif
C
      GO TO 9999
C
C
C
C     ========= JCODE = 2 : MORTRAN OVERFLOW ==========
C
2000  continue
      write (olupr,2900)
2900  format (' MORTRAN over/under FLOW')
C
      GO TO (2010,2020,2030,2040,2050,2060,2070,2080,2090),SUBCOD
C
C
2010  print 2011,T
2011  format(' STACK OVERFLOW WITH STACK NUMBER ',I2)
      GO TO 2999
C
2020  print 2021,T
2021  format(' STACK UNDERFLOW WITH STACK NUMBER ',I2)
      GO TO 2999
C
2030  print 2031
2031  format(' MACRO EXPANSION LOOP . OUTPUT OF EXPANSION BUFFER'
     +,' OVERWRITE INPUT')
C     Pattern part of the macro
      call TRACE(1,XPB,MPB)
      GO TO 2999
C
2040  print 2041
2041  format(' MACRO BUFFER OVERFLOW')
C     Matched text
      call TRACE(3,XPB,XP+1)
      GO TO 2999
C
2050  print 2051
2051  format(' EXPANSION BUFFER OVERFLOW')
      GO TO 2999
C
2060  print 2061
2061  format(' PARAMETER BUFFER OVERFLOW')
C     Matched text
      call TRACE(3,XPB,XP+1)
C     Pattern part of the macro
      call TRACE(1,XPB,MPB)
C     Parameters
      call TRACE(2,1,NP)
C     Replacement part of the macro
      call TRACE(5,XPB,MPB)
      GO TO 2999
C
2070  print 2071
2071  format(' XXXX BUFFER OVERFLOW')
      GO TO 2999
C
2080  print 2081
2081  format(' XXXX BUFFER OVERFLOW')
      GO TO 2999
C
2090  print 2091
2091  format(' XXXX BUFFER OVERFLOW')
      GO TO 2999
C
C     impression systematique
2999  continue
      go to 9999
C
C
C     ========= JCODE = 3 : INPUT OR GENERATED TEXT ERROR ==========
C
3000  continue
      write (olupr,3900)
3900  format ('  ')
C
      GO TO (3010,3020,3030,3040,3050,3060,3070,3080,3090),SUBCOD
C
3010  print 3011
3011  format (' UNCLOSED MTN BLOCK ')
      WRITE (olupr,3012) STP
3012  FORMAT (' STACK POINTERS : ',20I5)
      WRITE (olupr,3013)
3013  FORMAT (' (SHOULD BE ALL ZEROES) ')
      go to 3999
C
3020  print 3021
3021  format (' Unable to close an unopen MTN block ')
      go to 3999
C
3030  print 3031
3031  format (' UNCLOSED COMMENT STRING')
      if (QFLAG) then
        print *,
     +    (' The &Q0 option is more save. If you maintain &Q,the &L ')
        print *,
     +   (' option can be of great utility for debuging, you know.')
      endif
      go to 3999
C
3040  print 3041
3041  format (' UNCLOSED QUOTED STRING ')
      if (QFLAG) then
        print *,
     +    (' The &Q0 option is more save. If you maintain &Q,the &L ')
        print *,
     +   (' option can be of great utility for debuging, you know.')
      endif
      go to 3999
C
3050  print 3051,OTAB(T)
3051  format (' LABEL IN ERROR ; Character expected : ;',/,
     + 'Character found :',A1)
      call DUMPX(1,OP-5,OP+200,NUL)
      go to 3999
C
3060  print 3061
3061  format ('Unclosed Macro or a one space character is missing ')
      go to 3999
C
3070  print 3071
3071  format (' ')
      go to 3999
C
3080  print 3081
3081  format (' ')
      go to 3999
C
3090  print 3091
3091  format (' ')
      go to 3999
C
C
C     impression systematique
3999  continue
      go to 9999
C
C
C     ========= JCODE = 4 : MORTRAN READ/WRITE ERRORS ==========
C
C
4000  continue
      write (olupr,4900)
4900  format ('MORTRAN READ/WRITE ERRORS')
C
      GO TO (4010,4020,4030,4040,4050,4060,4070,4080,4090),SUBCOD
C
4010  print 4011,T,KCHMX
4011  format(1x,'File Name is too long (',I3,' characters). Only ',i3
     *,'characters are allowed')
      go to 4999
C
4020  print 4021,T
4021  format(1x,'Unable to open this file. Status =',I8)
      go to 4999
C
4030  print 4031,T,NINUMX
4031  format(1x,'Too many input file Open (',I2,'). Only ',I2
     *,' allowed')
      go to 4999
C
4040  print 4041
4041  format (' ')
      go to 4999
C
4050  print 4051
4051  format (' ')
      go to 4999
C
4060  print 4061
4061  format (' ')
      go to 4999
C
4070  print 4071
4071  format (' ')
      go to 4999
C
4080  print 4081
4081  format (' ')
      go to 4999
C
4090  print 4091
4091  format (' ')
      go to 4999
C
C     impression systematique
4999  continue
      go to 9999
C
C
C     ========= JCODE = 5 : CCA ERRORS  ==========
C
5000  continue
      write (olupr,5900)
5900  format (' CONTROL CARD ERROR')
C
      GO TO (5010,5020,5030,5040,5050,5060,5070,5080,5090),SUBCOD
C
5010  print 5011,OTAB(T)
5011  format (' Bad Charcter is :',A1)
      go to 5999
C
5020  print 5021
5021  format (' ')
      go to 5999
C
5030  print 5031
5031  format (' ')
      go to 5999
C
5040  print 5041
5041  format (' ')
      go to 5999
C
5050  print 5051
5051  format (' ')
      go to 5999
C
5060  print 5061
5061  format (' ')
      go to 5999
C
5070  print 5071
5071  format (' ')
      go to 5999
C
5080  print 5081
5081  format (' ')
      go to 5999
C
5090  print 5091
5091  format (' ')
      go to 5999
C
C
C     impression systematique
5999  continue
C     Dump expansion Buffer
      call DUMPX(1,XPB,XP,255)
      go to 9999
C
C
6000  continue
C
C     impression systematique
6999  continue
      go to 9999
C
C
7000  continue
C
C     impression systematique
7999  continue
      go to 9999
C
C
8000  continue
C
C     impression systematique
8999  continue
      go to 9999
C
C
C
C
C     ========= JCODE = 9 : USER define ERRORS  ==========
C
9000  continue
C
      GO TO (9010,9020,9030,9040,9050,9060,9070,9080,9090),SUBCOD
C
9010  continue
      MpLoc = T +1
      call M2ASC (M(MpLoc),Mdim-MpLoc,Nul,B,BP,BDIM)
      if (BP.eq.0) then
        print *,'No Message'
      else
        print 9012,(B(I),I=1,BP)
9012    format(1x,100A1)
      endif
      go to 9900
c
9020  continue
      go to 9900
c
9030  continue
      go to 9900
c
9040  continue
      go to 9900
c
9050  continue
      go to 9900
c
9060  continue
      go to 9900
c
9070  continue
      go to 9900
c
9080  continue
      go to 9900
c
9090  continue
      go to 9900
c
C     impression systematique
9900  continue
C     ==============  END OF ERRARE  ==============
C
9999  continue
      if (LEVEL.ge.3) go to 9990
      if (NERR.ge.NERRMX.or.NWARN.ge.NWARMX) then
        print *,'TOO MUCH ERRORS OR WARNINGS'
        GO TO 9990
      endif
      if (Level.gt.0) then
        print *,'Last MTN instruction :'
        call M2ASC (Y(1),YP,Nul,B,BP,BDIM)
        print 9993,(B(I),I=1,BP)
9993    format(1x,100A1)
        print *,'Last line read :'
        print *,LINSTR
      endif
      print *
      return
C
9990  continue
      print 9991,INU,INUNAM(INUSTP)
9991  format (1x,'Input File : unit=',I2,'  name=',A40)
      print 9992,TITLE
9992  format (1x,'Routine : ',24A1)
      print *,'Last line read :'
      print *,LINSTR
      REWIND OUTU
      ENDFILE OUTU
C     impression de la version de MOARTRAN et de sa date
C     de creation
      ITIMEQQ=1638
      IDATEQQ=20100307
      WRITE(olupr,105) IDATQQ,ITIMQQ
  105 FORMAT (/1X,'MORTRAN STOP',5X,
     + 30HMP2A      3.07/01  06/08/2008 
     +,' Instalation : ',I8,' at ',I4.4)
        stop 'Error in MTN *** ERROR *** ERROR *** ERROR ***'
      END
C
