#! /bin/sh
###############################################################
#
if [ "z$srcdir" = "z" ]; then
	srcdir=.
fi

rm -f test_zinit.lis test_zinit.output

../src/mtn >> test_zinit.lis <<EOI
&vtest_zinit.output
&u$srcdir/../mac/mtn.mac
&u$srcdir/zdl.mac
&'*KEEP,#.'=';#**KEEP,#1.;#N;'
&'*KEND.'=';#**KEND.;#N;'
;
&L0
&u$srcdir/test_zinit.input
&E
EOI
exit_error=$?
if [ $exit_error != 0 ]; then
	exit $exit_error
fi

# diff -u is more readable but not available on all platforms.
diff $srcdir/test_zinit.output.ok test_zinit.output
exit $?
